Overview | Package | Class | Tree | Deprecated | Index | Help
| J2EE1.4 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.servlet
Class UnavailableException

    java.lang.Object
      java.lang.Throwable
          java.lang.Exception
              javax.servlet.ServletException
                  javax.servlet.UnavailableException

All Implemented Interfaces:
  java.io.Serializable

public class UnavailableException
extends ServletException

Defines an exception that a servlet or filter throws to indicate that it is permanently or temporarily unavailable.

When a servlet or filter is permanently unavailable, something is wrong with it, and it cannot handle requests until some action is taken. For example, a servlet might be configured incorrectly, or a filter's state may be corrupted. The component should log both the error and the corrective action that is needed.

A servlet or filter is temporarily unavailable if it cannot handle requests momentarily due to some system-wide problem. For example, a third-tier server might not be accessible, or there may be insufficient memory or disk storage to handle requests. A system administrator may need to take corrective action.

Servlet containers can safely treat both types of unavailable exceptions in the same way. However, treating temporary unavailability effectively makes the servlet container more robust. Specifically, the servlet container might block requests to the servlet or filter for a period of time suggested by the exception, rather than rejecting them until the servlet container restarts.

Version:
  $Version$
Author:
  Various
See Also:
  Serialized Form

Constructor Summary
`UnavailableException(int seconds, Servlet servlet, java.lang.String msg)` Deprecated. As of Java Servlet API 2.2, use `UnavailableException(String, int)` instead.
`UnavailableException(Servlet servlet, java.lang.String msg)` Deprecated. As of Java Servlet API 2.2, use `UnavailableException(String)` instead.
`UnavailableException(java.lang.String msg)` Constructs a new exception with a descriptive message indicating that the servlet is permanently unavailable.
`UnavailableException(java.lang.String msg, int seconds)` Constructs a new exception with a descriptive message indicating that the servlet is temporarily unavailable and giving an estimate of how long it will be unavailable.

Method Summary
`Servlet` | `getServlet()` Deprecated. As of Java Servlet API 2.2, with no replacement. Returns the servlet that is reporting its unavailability.
`int` | `getUnavailableSeconds()` Returns the number of seconds the servlet expects to be temporarily unavailable.
`boolean` | `isPermanent()` Returns a `boolean` indicating whether the servlet is permanently unavailable.

Methods inherited from class javax.servlet.ServletException
`getRootCause`

Methods inherited from class java.lang.Throwable
`fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### UnavailableException

    public UnavailableException(Servlet servlet,
                                java.lang.String msg)

  Deprecated. As of Java Servlet API 2.2, use `UnavailableException(String)` instead.

Parameters:
  `servlet` - the `Servlet` instance that is unavailable
  `msg` - a `String` specifying the descriptive message

### UnavailableException

    public UnavailableException(int seconds,
                                Servlet servlet,
                                java.lang.String msg)

  Deprecated. As of Java Servlet API 2.2, use `UnavailableException(String, int)` instead.

Parameters:
  `seconds` - an integer specifying the number of seconds the servlet expects to be unavailable; if zero or negative, indicates that the servlet can't make an estimate
  `servlet` - the `Servlet` that is unavailable
  `msg` - a `String` specifying the descriptive message, which can be written to a log file or displayed for the user.

### UnavailableException

    public UnavailableException(java.lang.String msg)

  Constructs a new exception with a descriptive message indicating that the servlet is permanently unavailable.

Parameters:
  `msg` - a `String` specifying the descriptive message

### UnavailableException

    public UnavailableException(java.lang.String msg,
                                int seconds)

  Constructs a new exception with a descriptive message indicating that the servlet is temporarily unavailable and giving an estimate of how long it will be unavailable.

  In some cases, the servlet cannot make an estimate. For example, the servlet might know that a server it needs is not running, but not be able to report how long it will take to be restored to functionality. This can be indicated with a negative or zero value for the `seconds` argument.

Parameters:
  `msg` - a `String` specifying the descriptive message, which can be written to a log file or displayed for the user.
  `seconds` - an integer specifying the number of seconds the servlet expects to be unavailable; if zero or negative, indicates that the servlet can't make an estimate

Method Detail

### isPermanent

    public boolean isPermanent()

  Returns a `boolean` indicating whether the servlet is permanently unavailable. If so, something is wrong with the servlet, and the system administrator must take some corrective action.

  Returns:
    `true` if the servlet is permanently unavailable; `false` if the servlet is available or temporarily unavailable

### getServlet

    public Servlet getServlet()

  Deprecated. As of Java Servlet API 2.2, with no replacement. Returns the servlet that is reporting its unavailability.

  Returns:
    the `Servlet` object that is throwing the `UnavailableException`

### getUnavailableSeconds

    public int getUnavailableSeconds()

  Returns the number of seconds the servlet expects to be temporarily unavailable.

  If this method returns a negative number, the servlet is permanently unavailable or cannot provide an estimate of how long it will be unavailable. No effort is made to correct for the time elapsed since the exception was first reported.

  Returns:
    an integer specifying the number of seconds the servlet will be temporarily unavailable, or a negative number if the servlet is permanently unavailable or cannot make an estimate

Overview | Package | Class | Tree | Deprecated | Index | Help
| J2EE1.4 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature

Copyright 2003 Sun Microsystems, Inc. All rights reserved.